﻿--[[
Name: Prat
Revision: $Revision: 21464 $
Author(s): Curney (asml8ed@gmail.com)
           Krtek (krtek4@gmail.com)
Inspired By: idChat2 by Industrial
Website: http://www.wowace.com/files/index.php?path=Prat/
Documentation: http://www.wowace.com/wiki/Prat
SVN: http://svn.wowace.com/wowace/trunk/Prat/
Description: A framework for chat frame modules.
Dependencies: Ace2
]]

local L = AceLibrary("AceLocale-2.2"):new("Prat")

L:RegisterTranslations("enUS", function() return {
    ["Prat"] = true,
    ["A framework for chat frame modules."] = true,
    ["Disabled Modules"] = true,
} end)

L:RegisterTranslations("zhCN", function() return {
    ["Prat"] = "Prat",
    ["A framework for chat frame modules."] = "聊天窗口增加插件。",
} end)

L:RegisterTranslations("koKR", function() return {
    ["Prat"] = "Prat",
    ["A framework for chat frame modules."] = "대화창 모듈에 대한 프레임워크",
    ["Disabled Modules"] = "비활성화된 모듈",
} end)

L:RegisterTranslations("zhTW", function() return {
    ["Prat"] = "Prat",
    ["A framework for chat frame modules."] = "整合的聊天框架模組。",
} end)

L:RegisterTranslations("esES", function() return {
    ["Prat"] = "Prat",
    ["A framework for chat frame modules."] = "Un entorno para m\195\179dulos de chat.",
    ["Disabled Modules"] = "M\195\179dulos Desactivados",
} end)

L:RegisterTranslations("deDE", function() return {
    ["Prat"] = "Prat",
    ["A framework for chat frame modules."] = "Ein Grundaddon f\195\188r Chatfenster Module",
} end)

Prat = AceLibrary("AceAddon-2.0"):new("AceConsole-2.0", "AceDB-2.0", "AceDebug-2.0", "AceEvent-2.0", "AceHook-2.1", "AceModuleCore-2.0")


Prat:RegisterDB("PratDB", "PratPerCharDB")
Prat:SetModuleMixins("AceEvent-2.0", "AceHook-2.1",  "AceDebug-2.0")
Prat.Options = {
    name = L["Prat"],
    desc = L["A framework for chat frame modules."],
    type = "group",
    args = {
		optsep = {
			order = 101,
			type = 'header',
		},	    
		disabledmods = {
			order = 102,
			type = 'group',
			name = L["Disabled Modules"],
			desc = L["Disabled Modules"],
			args = {}
		},	   
    }
}



function Prat:OnInitialize()
	Prat:RegisterDefaults("profile", {
		debug = false,
	})
	
	self:RegisterEvent("Ace2_AddonDisabled")
	self:RegisterEvent("Ace2_AddonEnabled")
	
	self:RegisterEvent("AceEvent_FullyInitialized")
end

function Prat:AceEvent_FullyInitialized()
	self:SetDebugging(self.db.profile.debug)
	
	-- hack
	self:Ace2_AddonDisabled(self)
	self:Ace2_AddonEnabled(self)
end

function Prat:Ace2_AddonDisabled(mod)
	self:Debug("Ace2_AddonDisabled - "..mod.name)
	for k,v in pairs(Prat.Options.args) do
		if self:HasModule(k) then 
			if not self:IsModuleActive(k) then 
				Prat.Options.args.disabledmods.args[k] = v
				Prat.Options.args[k] = nil
			end
		end
	end
end
function Prat:Ace2_AddonEnabled(mod)
	self:Debug("Ace2_AddonEnabled - "..mod.name)
	for k,v in pairs(Prat.Options.args.disabledmods.args) do
		if self:HasModule(k) then 
			if self:IsModuleActive(k) then 
				Prat.Options.args[k] = v
				Prat.Options.args.disabledmods.args[k] = nil
			end
		end
	end
end

Prat:RegisterChatCommand({"/prat"}, Prat.Options)


Prat.sounds = {
	popup = "Interface\\AddOns\\Prat\\sounds\\chatmod1.mp3",
}

function Prat:OnDebugEnable()
	self.db.profile.debug = true
	self:Debug("Debug - ON")
end	

function Prat:OnDebugDisable()
	self.db.profile.debug = false
	self:Debug("Debug - OFF")
end	
