-- Gotta have Prat
if not Prat then return end

if not AceLibrary:HasInstance("FuBarPlugin-2.0") then return end

local L = AceLibrary("AceLocale-2.2"):new("PratFu")

L:RegisterTranslations("enUS", function() return {
    ["Prat"] = true,
    ["Options Menu"] = true,
    ["FuBar"] = true,
    ["minimap"] = true,
    ["Minimap"] = true,
    ["Toggle the minimap button."] = true,
    ["Show it again with /prat minimap."] = true,
    ["%s icon is now %s."] = true,
    ["hidden"] = true,
    ["shown"] = true,
    ["The standard FuBar options."] = true,
    ["FuBar Options"] = true,
} end)

-- Code from bigwigs can be used to provide a console command)
local mm = Prat:NewModule("minimap")
mm.hasFuBar = IsAddOnLoaded("FuBar") and FuBar
Prat.Options["minimap"] = not mm.hasFuBar and {
	type = "toggle",
	name = L["Minimap"],
	desc = L["Toggle the minimap button."],
	get = function() return PratFu.minimapFrame and PratFu.minimapFrame:IsVisible() or false end,
	set = function(v)
		if v then
			PratFu:Show()
		else
			PratFu:Hide()
			Prat:Print(L["Show it again with /prat minimap."])
		end
	end,
	map = {[false] = L["hidden"], [true] = L["shown"]},
	message = L["%s icon is now %s."],
	hidden = function() return mm.hasFuBar end,
}

PratFu = AceLibrary("AceAddon-2.0"):new("FuBarPlugin-2.0", "AceDebug-2.0", "AceConsole-2.0", "AceDB-2.0", "AceEvent-2.0")
PratFu:RegisterDB("PratFuDB")
PratFu.title = "Prat"
PratFu.name = "FuBar - Prat"

PratFu.hasIcon = true
PratFu.cannotDetachTooltip = true
PratFu.hideWithoutStandby = true

PratFu.OnMenuRequest = Prat.Options
local args = AceLibrary("FuBarPlugin-2.0"):GetAceOptionsDataTable(PratFu)
for k,v in pairs(args) do
	if PratFu.OnMenuRequest.args[k] == nil then
		PratFu.OnMenuRequest.args[k] = v
	end
end


