﻿local L = AceLibrary("AceLocale-2.2"):new("CopyChat")
L:RegisterTranslations("enUS", function() return {
	["CopyChat"] = true,
	["A module to let you copy text from the chat."] = true,
	["Copy"] = true,
	["Copy all of the text in the selected chat frame into an edit box"] = true,
	["Toggle"] = true,
	["Toggle the module on and off."] = true,
} end)

L:RegisterTranslations("deDE", function() return {
	["CopyChat"] = "Chat Kopieren",
	["A module to let you copy text from the chat."] = "Ein Modul das dich Text aus dem Chat kopieren l\195\164\195\182t.",
	["Copy"] = "Kopieren",
	["Copy all of the text in the selected chat frame into an edit box"] = "Kopiert den gesammten Text im ausgew\195\164hlten Chatfenster in das Editierfeld.",
	["Toggle"] = "Einschalten",
	["Toggle the module on and off."] = "Schaltet das Modul an und aus.",
} end)

PratCC = Prat:NewModule("CopyChat")

function PratCC:OnInitialize()
    self.db = Prat:AcquireDBNamespace("CopyChat")
    Prat:RegisterDefaults("CopyChat", "profile", {
        on  = true,
    })
    Prat:ToggleModuleActive("CopyChat", self.db.profile.on)    
    
    Prat.Options.args.CopyChat = {
        name = L["CopyChat"],
        desc = L["A module to let you copy text from the chat."],
        type = "group",
        args = {
             toggle = {
                name = L["Toggle"],
                desc = L["Toggle the module on and off."],
                type = "toggle",
                order = 200,
                get = function() return self.db.profile.on end,
                set = function() self.db.profile.on = Prat:ToggleModuleActive("CopyChat") end
            },
	         copy = {
	             name = L["Copy"],
	             desc = L["Copy all of the text in the selected chat frame into an edit box"],
	             type = "execute",
	             order = 200,
	             func = function() PratCC:ScrapeChatFrame(SELECTED_CHAT_FRAME) HideDropDownMenu(1) end
	         }            
            
        }
    }
end


function PratCC:OnEnable()

end


function PratCC:OnDisable()
	PratCCFrame:Hide()
end


PratCC.lines = {}
PratCC.str = nil

function PratCC:ScrapeChatFrame(frame)
	local lines = { frame:GetRegions() }
	
	PratCC.lines = {}
	
	for i=#lines, 1, -1 do
		if lines[i]:GetObjectType() == "FontString" then
			table.insert(self.lines, lines[i]:GetText())
		end
	end
	self.str = table.concat(self.lines, "\n")
	
	PratCCText:SetText(frame:GetName().." Text", lines)
	PratCCFrameScrollText:SetText(self.str)
	PratCCFrame:Show()
end


function PratCC:OnTextChanged()
	if this:GetText() ~= self.str then
		this:SetText(self.str)
	end
	local s = PratCCFrameScrollScrollBar
	this:GetParent():UpdateScrollChildRect()
	local _, m = s:GetMinMaxValues()
	if m > 0 and this.max ~= m then
		this.max = m
		s:SetValue(m)
	end
end

function PratCC:Hide()
	PratCCFrame:Hide()
end
