﻿local L = AceLibrary("AceLocale-2.2"):new("GroupJoinNoise")

L:RegisterTranslations("enUS", function() return {
    ["GroupJoinNoise"] = true,
    ["A module to remove the sound and delay caused by people joining/leaving your party/raid."] = true,
    ["Toggle"] = true,
    ["Toggle the module on and off."] = true,
} end)

L:RegisterTranslations("deDE", function() return {
    ["GroupJoinNoise"] = "Gruppe betreten Ton",
    ["A module to remove the sound and delay caused by people joining/leaving your party/raid."] = "Ein Modul um den Sound und die Verz\195\182gerrung zu entfernen ausgel\195\182st durch jemanden der deine Gruppe/Schlachtgruppe betritt/verl\195\164sst.",
    ["Toggle"] = "Einschalten",
    ["Toggle the module on and off."] = "Schaltet das Modul an und aus.",
} end)

L:RegisterTranslations("koKR", function() return {
    ["GroupJoinNoise"] = "파티참여차단",
    ["A module to remove the sound and delay caused by people joining/leaving your party/raid."] = "파티/공격대에 참여/떠남에 의해 발생하는 소리와 지연시간을 제거하는 모듈입니다.",
    ["Toggle"] = "전환",
    ["Toggle the module on and off."] = "모듈 켜고 끄기 전환.",
} end)

L:RegisterTranslations("esES", function() return {
    ["GroupJoinNoise"] = "Ruido de Uni\195\179n a Grupo",
    ["A module to remove the sound and delay caused by people joining/leaving your party/raid."] = "Un m\195\179dulo que elimina el sonido y retraso causado cuando la gente entra o sale de tu grupo o banda",
    ["Toggle"] = "Activar",
    ["Toggle the module on and off."] = "Activa y desactiva el m\195\179dulo",
} end)

PratGJN= Prat:NewModule("GroupJoinNoise")

function PratGJN:OnInitialize()
    self.db = Prat:AcquireDBNamespace("GroupJoinNoise")
    Prat:RegisterDefaults("GroupJoinNoise", "profile", {
        on = true,
    })
    Prat:ToggleModuleActive("GroupJoinNoise", self.db.profile.on)    
    
    Prat.Options.args.GroupJoinNoise = {
        name = L["GroupJoinNoise"],
        desc = L["A module to remove the sound and delay caused by people joining/leaving your party/raid."],
        type = "group",
        args = {
             toggle = {
                name = L["Toggle"],
                desc = L["Toggle the module on and off."],
                type = "toggle",
                order = 200,
                get = function() return self.db.profile.on end,
                set = function() self.db.profile.on = Prat:ToggleModuleActive("GroupJoinNoise") end
            }
        }
    }
end

function PratGJN:OnEnable()
    self:Hook("LFGParentFrameTab2_OnClick", true)
end


--[[------------------------------------------------
	Core Functions
------------------------------------------------]]--


function PratGJN:LFGParentFrameTab2_OnClick()	
	if ( LFGParentFrame:IsShown() ) then		
		self.hooks.LFGParentFrameTab2_OnClick()
	end
end