﻿--[[
Name: Prat_Scroll
Revision: $Revision: 22524 $
Author(s): Curney (asml8ed@gmail.com)
           Krtek (krtek4@gmail.com)
Inspired by: idChat2_PlayerNames by Industrial
Website: http://www.wowace.com/files/index.php?path=Prat/
Documentation: http://www.wowace.com/wiki/Prat/Integrated_Modules#Scroll
SVN: http://svn.wowace.com/wowace/trunk/Prat/
Description: Module for Prat that enables mousewheel scrolling for chat windows (default=on).
Dependencies: Prat
]]

local L = AceLibrary("AceLocale-2.2"):new("PratScrolling")

L:RegisterTranslations("enUS", function() return {
    ["Scroll"] = true,
    ["Chat window scrolling options."] = true,
    ["Enable MouseWheel"] = true,
    ["Toggle MouseWheel support for chat windows on and off."] = true,
    ["Chat%dMouseWheel"] = true,
    ["Toggles MouseWheel support on and off for chat window %d."] = true,
    ["Set MouseWheel Speed"] = true,
    ["Sets number of lines mousewheel will scroll."] = true,
    ["Set Ctrl+MouseWheel Speed"] = true,
    ["Sets number of lines mousewheel will scroll when ctrl is pressed."] = true,
    ["Enable TheLowDown"] = true,
    ["Toggle jumping to the bottom of chat windows on and off."] = true,
    ["Chat%dLowDown"] = true,
    ["Toggles jumping to the bottom on and off for chat window %d."] = true,
    ["Set TheLowDown Delay"] = true,
    ["Sets time to wait before jumping to the bottom of chat windows."] = true,
    ["Toggle"] = true,
    ["Toggle the module on and off."] = true,
} end)

-- L:RegisterTranslations("zhCN", function() return {
-- 	["Scroll"] = "滚动",
-- 	["Chat window scrolling options."] = "聊天窗口滚动选项。",
-- 	["MouseScroll"] = "鼠标滚动",
-- 	["Toggle mousewheel scrolling in chat windows on and off."] = "切换鼠标滚动聊天窗口功能打开与关闭。",
-- 	["Chat%dScrolling"] = "窗口%d滚动",
-- 	["Toggles mouse scrolling on and off for chat window %d."] = "切换聊天窗口 %d 鼠标滚动功能打开与关闭。",
-- 	["Normal ScrollSpeed"] = "滚动速度",
-- 	["Sets number of lines mousewheel will scroll."] = "鼠标滚动时卷动的行数。",
-- 	["Ctrl ScrollSpeed"] = "<Ctrl>滚动速度",
-- 	["Sets number of lines mousewheel will scroll when ctrl is pressed."] = "设置按下<Ctrl>时鼠标滚轮的滚动行数。",
-- 	["Toggle"] = "切换",
-- 	["Toggle the module on and off."] = "切换此模块的打开与关闭",
-- } end)
-- 
-- L:RegisterTranslations("koKR", function() return {
-- 	["Scroll"] = "스크롤",
-- 	["Chat window scrolling options."] = "대화창 스크롤 설정입니다.",
-- 	["MouseScroll"] = "마우스 스크롤",
-- 	["Toggle mousewheel scrolling in chat windows on and off."] = "대화창을 마우스횔로 스크롤하는 것을 켜고 끄기를 전환합니다.",
-- 	["Chat%dScrolling"] = "대화창%d 스크롤",
-- 	["Toggles mouse scrolling on and off for chat window %d."] = "대화창 %d에 대한 마우스 스크롤을 켜고 끄기를 전환합니다.",
-- 	["Normal ScrollSpeed"] = "일반 스크롤 속도",
-- 	["Sets number of lines mousewheel will scroll."] = "설정한 라인 수 만큼 스크롤됩니다.",
-- 	["Ctrl ScrollSpeed"] = "컨트롤 스크롤 속도",
-- 	["Sets number of lines mousewheel will scroll when ctrl is pressed."] = "컨트롤키를 눌렀을 때 설정된 라인 수만큼 스크롤됩니다.",
-- 	["Toggle"] = "전환",
-- 	["Toggle the module on and off."] = "모듈 켜고 끄기를 전환합니다.",
-- 	["TheLowDown"] = "자동하단",
-- 	["Toggle jumping to the bottom in chat windows on and off."] = "대화창 하단으로 바로가기 기능 켜고 끄기를 전환합니다.",
-- 	["Chat%dLowDown"] = "대화창%d자동하단",
-- 	["Toggles jumping to the bottom on and off for chat window %d."] = "대화창 %d 하단으로 바로가기 기능 켜고 끄기를 전환합니다.",
-- 	["TheLowDown delay"] = "자동하단 지연시간",
-- 	["Sets time after which we want to jump to the bottom."] = "몇초 후 아래로 바로가기 할 시간을 설정합니다.",
-- } end)
-- 
-- L:RegisterTranslations("zhTW", function() return {
--     ["Scroll"] = "滾動",
--     ["Chat window scrolling options."] = "聊天視窗滾動選項。",
--     ["MouseScroll"] = "滑鼠滾動",
--     ["Toggle mousewheel scrolling in chat windows on and off."] = "切換滑鼠滾動聊天視窗功能打開與關閉。",
--     ["Chat%dScrolling"] = "視窗%d滾動",
--     ["Toggles mouse scrolling on and off for chat window %d."] = "切換聊天視窗 %d 滑鼠滾動功能打開與關閉。",
--     ["Normal ScrollSpeed"] = "滾動速度",
--     ["Sets number of lines mousewheel will scroll."] = "視窗滾動時卷動的行數。",
--     ["Ctrl ScrollSpeed"] = "<Ctrl>滾動速度",
--     ["Sets number of lines mousewheel will scroll when ctrl is pressed."] = "設定按下<Ctrl>時視窗滾輪的行數。",
--     ["Toggle"] = "切換",
--     ["Toggle the module on and off."] = "切換打開或關閉此模組。",
-- } end)
-- 
-- L:RegisterTranslations("esES", function() return {
--     ["Scroll"] = "Desplazamiento Vertical",
--     ["Chat window scrolling options."] = "Opciones de desplazamiento vertical de las ventanas de chat",
--     ["MouseScroll"] = "Desplazamiento Vertical por Rat\195\179n",
--     ["Toggle mousewheel scrolling in chat windows on and off."] = "Determina si se activa el desplazamiento vertical en las ventanas de chat con la rueda del rat\195\179n",
--     ["Chat%dScrolling"] = "Desplazamiento Vertical de Chat %d",
--     ["Toggles mouse scrolling on and off for chat window %d."] = "Determina si se activa el desplazamiento vertical por rat\195\179n para la ventana %d",
--     ["Normal ScrollSpeed"] = "Velocidad de Desplazamiento Vertical Normal",
--     ["Sets number of lines mousewheel will scroll."] = "Establece el n\195\186mero de l\195\173neas que la rueda del rat\195\179n desplazar\195\161 verticalmente",
--     ["Ctrl ScrollSpeed"] = "Velocidad de Desplazamiento Vertical con Ctrl",
--     ["Sets number of lines mousewheel will scroll when ctrl is pressed."] = "Establece el n\195\186mero de l\195\173neas que el rat\195\179n desplazar\195\161 verticalmente cuando se presione la tecla Control",
--     ["Toggle"] = "Activar",
--     ["Toggle the module on and off."] = "Activa y desactiva este m\195\179dulo.",
--     ["TheLowDown"] = "Saltar Abajo",
--     ["Toggle jumping to the bottom in chat windows on and off."] = "Determina si se activa el salto a la parte inferior de la ventana de chat",
--     ["Chat%dLowDown"] = "Salto Abajo de Chat %d",
--     ["Toggles jumping to the bottom on and off for chat window %d."] = "Determina si se activa el salto a la parte inferior para la ventana de chat %d",
--     ["TheLowDown delay"] = "Retraso de Salto Abajo",
--     ["Sets time after which we want to jump to the bottom."] = "Establece el tiempo tras el que quieres saltar abajo",
-- } end)
-- 
-- L:RegisterTranslations("deDE", function() return {
--     ["Scroll"] = "Scrollen",
--     ["Chat window scrolling options."] = "Chatfenster Scrollen Optionen",
--     ["MouseScroll"] = "Mouse Scrollen",
--     ["Toggle mousewheel scrolling in chat windows on and off."] = "Schaltet das Scrollen mit dem Mausrad in Chatfenstern an und aus.",
--     ["Chat%dScrolling"] = "Chat %d Scrollen",
--     ["Toggles mouse scrolling on and off for chat window %d."] = "Schaltet Mause Scrollen an und aus f\195\188r das chatfenster %d.",
--     ["Normal ScrollSpeed"] = "Normale Scrollgeschwindigkeit",
--     ["Sets number of lines mousewheel will scroll."] = "Stellt die Anzahl an Zeilen ein die mit dem Mausrad gescrollt werden.",
--     ["Ctrl ScrollSpeed"] = "Strg Scrollgeschwindigkeit",
--     ["Sets number of lines mousewheel will scroll when ctrl is pressed."] = "stellt ein wieviele Zeilen gescrollt werden wenn Strg gedr\195\188ckt gehalten wird.",
--     ["Toggle"] = "Einschalten",
--     ["Toggle the module on and off."] = "Schaltet dieses Modul an und aus",
--     ["TheLowDown"] = "Ganz runter",
--     ["Toggle jumping to the bottom in chat windows on and off."] = "Schaltet das springen zum Ende des Chattextes in Chatfenstern an und aus.",
--     ["Chat%dLowDown"] = "Chat %d Ganz runter",
--     ["Toggles jumping to the bottom on and off for chat window %d."] = "Schaltet das springen zum Ende an und aus f\195\188r das Chatfenster %d.",
--     ["TheLowDown delay"] = "Ganz runter verz\195\182gerrung",
--     ["Sets time after which we want to jump to the bottom."] = "Stellt ein nach welcher Zeit der Chattext zum Ende Springen soll.",
-- } end)

Prat_Scroll = Prat:NewModule("scroll")

function Prat_Scroll:OnInitialize()
    self.db = Prat:AcquireDBNamespace("Scrolling")
    Prat:RegisterDefaults("Scrolling", "profile", {
        on = true,
        chatscrolls = {true, true, true, true, true, true, true},
        normscrollspeed = 1,
        ctrlscrollspeed = 3,
        lowdown = {true, true, true, true, true, true, true},
        lowdowndelay = 20,
    })
    Prat:ToggleModuleActive("scroll", self.db.profile.on)    
    
    Prat.Options.args.scroll = {
        name = L["Scroll"],
        desc = L["Chat window scrolling options."],
        type = "group",
        args = {
            mousewheel = {
                name = L["Enable MouseWheel"],
                desc = L["Toggle MouseWheel support for chat windows on and off."],
                type = "group",
                order = 170,
                args = {
                    chat1 = {
                        name = string.format(L["Chat%dMouseWheel"], 1),
                        desc = string.format(L["Toggles MouseWheel support on and off for chat window %d."], 1),
                        type = "toggle",
                        get = function() return self.db.profile.chatscrolls[1] end,
                        set = function(v) self.db.profile.chatscrolls[1] = v; self:MouseWheel(1,v) end
                    },
                    chat2 = {
                        name = string.format(L["Chat%dMouseWheel"], 2),
                        desc = string.format(L["Toggles MouseWheel support on and off for chat window %d."], 2),
                        type = "toggle",
                        get = function() return self.db.profile.chatscrolls[2] end,
                        set = function(v) self.db.profile.chatscrolls[2] = v; self:MouseWheel(2,v) end
                    },
                    chat3 = {
                        name = string.format(L["Chat%dMouseWheel"], 3),
                        desc = string.format(L["Toggles MouseWheel support on and off for chat window %d."], 3),
                        type = "toggle",
                        get = function() return self.db.profile.chatscrolls[3] end,
                        set = function(v) self.db.profile.chatscrolls[3] = v; self:MouseWheel(3,v) end
                    },
                    chat4 = {
                        name = string.format(L["Chat%dMouseWheel"], 4),
                        desc = string.format(L["Toggles MouseWheel support on and off for chat window %d."], 4),
                        type = "toggle",
                        get = function() return self.db.profile.chatscrolls[4] end,
                        set = function(v) self.db.profile.chatscrolls[4] = v; self:MouseWheel(4,v) end
                    },
                    chat5 = {
                        name = string.format(L["Chat%dMouseWheel"], 5),
                        desc = string.format(L["Toggles MouseWheel support on and off for chat window %d."], 5),
                        type = "toggle",
                        get = function() return self.db.profile.chatscrolls[5] end,
                        set = function(v) self.db.profile.chatscrolls[5] = v; self:MouseWheel(5,v) end
                    },
                    chat6 = {
                        name = string.format(L["Chat%dMouseWheel"], 6),
                        desc = string.format(L["Toggles MouseWheel support on and off for chat window %d."], 6),
                        type = "toggle",
                        get = function() return self.db.profile.chatscrolls[6] end,
                        set = function(v) self.db.profile.chatscrolls[6] = v; self:MouseWheel(6,v) end
                    },
                    chat7 = {
                        name = string.format(L["Chat%dMouseWheel"], 7),
                        desc = string.format(L["Toggles MouseWheel support on and off for chat window %d."], 7),
                        type = "toggle",
                        get = function() return self.db.profile.chatscrolls[7] end,
                        set = function(v) self.db.profile.chatscrolls[7] = v; self:MouseWheel(7,v) end
                    }
                }
            },
            mousewheelspeed = {
                name = L["Set MouseWheel Speed"],
                desc = L["Sets number of lines mousewheel will scroll."],
                type = "range",
                order = 180,
                get = function() return self.db.profile.normscrollspeed end,
                set = function(v) self.db.profile.normscrollspeed = v end,
                min = 1,
                max = 21,
                step = 1,
            },
            ctrlmousewheelspeed = {
                name = L["Set Ctrl+MouseWheel Speed"],
                desc = L["Sets number of lines mousewheel will scroll when ctrl is pressed."],
                type = "range",
                order = 190,
                get = function() return self.db.profile.ctrlscrollspeed end,
                set = function(v) self.db.profile.ctrlscrollspeed = v end,
                min = 3,
                max = 21,
                step = 3,
            },
            lowdown = {
                name = L["Enable TheLowDown"],
                desc = L["Toggle jumping to the bottom of chat windows on and off."],
                type = "group",
                order = 200,
                args = {
                    chat1 = {
                        name = string.format(L["Chat%dLowDown"], 1),
                        desc = string.format(L["Toggles jumping to the bottom on and off for chat window %d."], 1),
                        type = "toggle",
                        get = function() return self.db.profile.lowdown[1] end,
                        set = function(v) self.db.profile.lowdown[1] = v; self:LowDown(1,v) end
                    },
                    chat2 = {
                         name = string.format(L["Chat%dLowDown"], 2),
                        desc = string.format(L["Toggles jumping to the bottom on and off for chat window %d."], 2),
                        type = "toggle",
                        get = function() return self.db.profile.lowdown[2] end,
                        set = function(v) self.db.profile.lowdown[2] = v; self:LowDown(2,v) end
                    },
                    chat3 = {
                        name = string.format(L["Chat%dLowDown"], 3),
                        desc = string.format(L["Toggles jumping to the bottom on and off for chat window %d."], 3),
                        type = "toggle",
                        get = function() return self.db.profile.lowdown[3] end,
                        set = function(v) self.db.profile.lowdown[3] = v; self:LowDown(3,v) end
                    },
                    chat4 = {
                         name = string.format(L["Chat%dLowDown"], 4),
                        desc = string.format(L["Toggles jumping to the bottom on and off for chat window %d."], 4),
                        type = "toggle",
                        get = function() return self.db.profile.lowdown[4] end,
                        set = function(v) self.db.profile.lowdown[4] = v; self:LowDown(4,v) end
                    },
                    chat5 = {
                         name = string.format(L["Chat%dLowDown"], 5),
                        desc = string.format(L["Toggles jumping to the bottom on and off for chat window %d."], 5),
                        type = "toggle",
                        get = function() return self.db.profile.lowdown[5] end,
                        set = function(v) self.db.profile.lowdown[5] = v; self:LowDown(5,v) end
                    },
                    chat6 = {
                        name = string.format(L["Chat%dLowDown"], 6),
                        desc = string.format(L["Toggles jumping to the bottom on and off for chat window %d."], 6),
                        type = "toggle",
                        get = function() return self.db.profile.lowdown[6] end,
                        set = function(v) self.db.profile.lowdown[6] = v; self:LowDown(6,v) end
                    },
                    chat7 = {
                        name = string.format(L["Chat%dLowDown"], 7),
                        desc = string.format(L["Toggles jumping to the bottom on and off for chat window %d."], 7),
                        type = "toggle",
                        get = function() return self.db.profile.lowdown[7] end,
                        set = function(v) self.db.profile.lowdown[7] = v; self:LowDown(7,v) end
                    }
                }
            },
            lowdowndelay = {
                name = L["Set TheLowDown Delay"],
                desc = L["Sets time to wait before jumping to the bottom of chat windows."],
                type = "range",
                order = 210,
                get = function() return self.db.profile.lowdowndelay end,
                set = function(v) self.db.profile.lowdowndelay = v end,
                min = 1,
                max = 60,
                step = 1,
            },
            toggle = {
                name = L["Toggle"],
                desc = L["Toggle the module on and off."],
                type = "toggle",
                order = 220,
                get = function() return self.db.profile.on end,
                set = function() self.db.profile.on = Prat:ToggleModuleActive("scroll") end,
            }
        }
    }
end

function Prat_Scroll:OnEnable()
    for i = 1,NUM_CHAT_WINDOWS do
        self:MouseWheel(i,self.db.profile.chatscrolls[i])
       	self:LowDown(i,self.db.profile.lowdown[i])
    end
end

function Prat_Scroll:OnDisable()
    for i = 1,NUM_CHAT_WINDOWS do
        self:MouseWheel(i,false)
       	self:LowDown(i,false)
    end
end

function Prat_Scroll:MouseWheel(id, enabled)
    local cf = getglobal("ChatFrame"..id)
    if enabled then
        cf:SetScript("OnMouseWheel", function()
            if (arg1 > 0) then
                if IsShiftKeyDown() then
                    cf:ScrollToTop()
                else
                    if IsControlKeyDown() then
                        for i = 1,self.db.profile.ctrlscrollspeed do
                            cf:ScrollUp()
                        end
                    else
                        for i = 1,self.db.profile.normscrollspeed do
                            cf:ScrollUp()
                        end
                    end
                end
            elseif (arg1 < 0) then
                if IsShiftKeyDown() then
                    cf:ScrollToBottom()
                else
                    if IsControlKeyDown() then
                        for i = 1,self.db.profile.ctrlscrollspeed do
                            cf:ScrollDown()
                        end
                    else
                        for i = 1,self.db.profile.normscrollspeed do
                            cf:ScrollDown()
                        end
                    end
                end
            end
        end)
        cf:EnableMouseWheel(true)
    else
        cf:SetScript("OnMouseWheel", nil)
        cf:EnableMouseWheel(false)
    end
end

function Prat_Scroll:LowDown(id, enabled)
	local name = "ChatFrame"..id
  local cf = getglobal(name)
	local funcs = {"ScrollUp", "ScrollDown", "ScrollToTop", "PageUp", "PageDown"}

  if enabled then
		for _,func in ipairs(funcs) do
			local f = function(cf)
				if self:IsEventScheduled(name.."DownTimeout") then self:CancelScheduledEvent(name.."DownTimeout") end
				self:ScheduleEvent(name.."DownTimeout", self.ResetFrame, self.db.profile.lowdowndelay, self, name)
			end
			self:SecureHook(cf, func, f)
		end
	else
		for _,func in ipairs(funcs) do
			if self:IsHooked(cf, func) then self:Unhook(cf, func) end
		end
	end
end

function Prat_Scroll:ResetFrame(name)
	local cf = getglobal(name)
	if not cf:AtBottom() then
		cf:ScrollToBottom()
	end
end